/* --*-C-*-- */
/* $Id: options.c.pl,v 1.12 2002/06/19 19:02:40 itz Exp $ */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <getopt.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>

#include "options.h"

static struct option {* $progname *}_options[] = {
{* foreach $opt (@opts) {
  my $a = ($opt->{arg} ? 'required_argument' : 'no_argument');
  $OUT .= qq({ "$opt->{name}", $a, 0, '$opt->{flag}' },\n);
} *}
  { 0, 0, 0, 0 }
};

static const char {* $progname *}_docstrings[] = 
"{* $whatis *}\n"
"Usage: {* $progname *} [OPTION]... [CONFIG_FILE]\n\n"
{* foreach $opt (@opts) {
    my $optline = qq(" -$opt->{flag}, --$opt->{name}");
    $optline .= qq( "=\U$opt->{name}") if $opt->{arg};
    $OUT .= $optline;
    $OUT .= ' "'. (" " x (($opt->{arg} ? 32 : 29) - length $optline)) . ' "';
    my $docstring = $opt->{docstring};
    $docstring =~ s|!NAME!|\U$opt->{name}| ;
    $OUT .= qq( "$docstring");
    $OUT .= qq(\n "\\n" \n);
} *}
  
"\nReport bugs to {* $email *}.\n"
;

void
print_version_and_copy()
{
  fprintf(stdout, "{* $progname *} %s protocol %s\n", VERSION, PROTOCOL);
  fprintf(stdout, "{* printable($copy) *}");
  exit(0);
}

{* foreach $opt (@opts) {
  if ($opt->{arg}) {
    $OUT .= qq(char* opt_$opt->{name} = 0;\n);
  } else {
    $OUT .= qq(int opt_$opt->{name} = 0;\n);
  }
} *}

void
parse_options(int argc, char** argv)
{
  int c;
  int i;
  static char optlist[] = "{* foreach $opt (@opts) { $OUT .= $opt->{flag}; if ($opt->{arg}) { $OUT .= ':'; } } *}";
  char* p;

  while ((c = getopt_long(argc, argv, optlist, {* $progname *}_options, &i)) != -1) {
    switch(c) {
      {* foreach $opt (@opts) {
        $OUT .= qq(
	case '$opt->{flag}': );
        if ($opt->{arg}) {
          $OUT .= qq(opt_$opt->{name} = optarg; );
        } else {
          $OUT .= qq(opt_$opt->{name} = 1; );
        }
        $OUT .= qq(break;\n);
      } *}
	case '?':
	default:
	print_docstrings(1);
    } /*switch*/
  } /*while*/

{* foreach $opt (@opts) {
     $OUT .= qq:  if (0 != (p = getenv("gim_$opt->{name}"))) {\n: ;
     if ($opt->{arg}) {
       $OUT .= qq:    if (opt_$opt->{name} == 0) opt_$opt->{name} = p;\n: ;
     } else {
       $OUT .= qq:    if (opt_$opt->{name} == 0) opt_$opt->{name} = atoi(p);\n: ;
     }
     $OUT .= qq:  }\n: ;
   }
*}

}

int
print_docstrings (int exit_code)
{
  fprintf(stdout, {* $progname *}_docstrings);
  exit(exit_code);
  return 0;                     /* not reached */
}

